/*
  yasep/dev/compact.js created by whygee at f-cpu.org
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
  created 2011-11-14 from yasep/defora/gen_asm.js

  Add a menu button, with key "compact", to create a window that
    creates and saves compacted versions of the CSS and JS source code.
*/

init_obj.push(compact={

  getCSS: function() {
    src="";
    for (var i in css_list)
      src+=FF.LoadFile(css_list[i]+'.css')+"\n";
    return src;
  },

  getJS: function() {
    var src="";

    for (var i in js_list)
      if (js_list[i][1]==1) // prod ?
        src+=FF.LoadFile(js_list[i][2]+'.js')+";";
    return src;
  },

  start: function() {
    var pre = document.createElement('pre');
    pre.innerHTML='<button id="save_CSS">Save index.prod.css</button><br>'
       +'<button id="save_JS">Save index.prod.js</button><br>'
       +'<button id="save_HTML">Save index.prod.html</button><br>'
       +'<button id="save_nano">Save js.nanorc</button><br>'
       +'<input id="minimize_dbg" type="checkbox"> Debug \\n';

    init_obj.dbg=getById("minimize_dbg",null,pre);

    // hook the actions :
    getById("save_CSS",null,pre).onclick=function(){
      savefile.save("index.prod.css",minimize(compact.getCSS(), "noSubst", init_obj.dbg.checked));
    };

    getById("save_JS",null,pre).onclick=function(){
      savefile.save("index.prod.js",minimize(compact.getJS(), null, init_obj.dbg.checked));
    };

    getById("save_HTML",null,pre).onclick=function(){
      var html=FF.LoadFile("index.dev.html");
      html = html.replace(/<script .*/,
          '<style type="text/css">'
         +minimize(compact.getCSS(), "noSubst", init_obj.dbg.checked)
         +'</style><script type="text/javascript">'
         +minimize(compact.getJS(),null, init_obj.dbg.checked)
         +"</script>");
      savefile.save("index.html",html);
    };

    getById("save_nano",null,pre).onclick=function(){
      var nanorc=FF.LoadFile("js.nanorc");
//      var nanoKeyWords = "color green \"\\<("  + JSkeyWords.replace(/ /g,"|") + ")\\>\"";
//      var nanoRedifinable = "color red \"\\<("+ Redifinable.replace(/ /g,"|") + ")\\>\"";
//      var nanoMethods = "color magenta \"\\<(" + JS_Methods.replace(/ /g,"|") + ")\\>\""; 

      var nanoKeyWords = "color green \"\\<(plip)\\>\"";
      var nanoRedifinable = "color red \"\\<(plap)\\>\"";
      var nanoMethods = "color magenta \"\\<(plop)\\>\""; 
      nanorc = nanorc.replace(/color green .*/ , nanoKeyWords);
      nanorc = nanorc.replace(/color red .*/, nanoRedifinable);
      nanorc = nanorc.replace(/color magenta .*/ , nanoMethods);

      savefile.save("js.nanorc",nanorc);
    };

    return(compact.win= ygwm.new_window( "Compact the website's files", null, pre,
       350, 300, 350, 70, false, true, true, true, false, "doc_gryl"));
  },

  init_obj: function() {
    compact.menuItem = menu.subMenuItem(menu.mainMenuItem("Dev"), "Compact", "compact");
  }
});

winman.register_key("compact",compact.start);
